var MOVE_NONE = 0;
var MOVE_LEVEL = 1;
var MOVE_COLOR = 2;
var MOVE_SAT = 3;

var moveType = MOVE_NONE;
var touchType = "";
var editNeedRender = true;
var sendLevel = false;
var sendSat = false;
var sendHue = false;
var touch0 = { x: 0, y: 0 };
var touch0Prev = { x: 0, y: 0 };

var colorPos = { x: 0, y: 0 };

// relative width of dimm and color secions
var dimmWidth = 0.2;
var dimmHeight = 0.42;
var colorWidth = 0.3;
var colorHeight = 0.52;
var colorMapHeight = 100;
var hueHeight = 800; // high of hue image
// canvas color kongfu
var colorCanvas = undefined;
var colorCtx = undefined;
var pageEditWidth = undefined;
var pageEditHeight = undefined;

// touch handler
var editHammer = undefined;
var sendCheckerActive = false;
var sendCheckTimer = undefined;

function sendCheck() {
    sendCheckTimer = undefined;

    if (!isSending) {
        sendState();
    }

    if (sendCheckerActive) {
        sendCheckTimer = setTimeout(sendCheck, 1000);
    }
}

function stopSendCheck() {
    sendCheckerActive = false;
    if (sendCheckTimer !== undefined) {
        clearTimeout(sendCheckTimer);
        sendCheckTimer = undefined;
    }
}

function sendState() {
    if (sendLevel || sendSat || sendHue) {
        var out = { };
        out.type = curEdit.obj.type;
        out.id = curEdit.obj.id;
        out.transitiontime = 9;

        // send level to device
        if (sendLevel) {
            sendLevel = false;
            out.on = curEdit.obj.state.on;
            out.bri = curEdit.level;
        }

        if (sendSat) {
            sendSat = false;
            out.sat = curEdit.sat;
        }

        if (sendHue) {
            sendHue = false;
            out.hue = curEdit.hue * 360.0 * 182.0444;
        }

        pushObjState(out);
    }
}

function setObjName(input) {
    var putUrl;
    var out = {};

    if (input.value === undefined) {
        console.log("no valid input field");
        return;
    }

    out.name = input.value;

    if (curEdit.obj.type === TYPE_LIGHT) {
        putUrl = '/api/' + apikey + '/lights/' + curEdit.obj.id;
    }
    else if (curEdit.obj.type === TYPE_GROUP) {
        putUrl = '/api/' + apikey + '/groups/' + curEdit.obj.id;
    }

    $.ajax({
        url: putUrl,
        type: 'PUT',
        contentType: 'application/json; charset=utf-8',
        data: JSON.stringify(out),
        dataType: 'json',
        success: function(data) {
            console.log("renamed to " + out.name);
        },
        error: function(jqXHR, textStatus, errorThrown) {
            console.log("textStatus:", textStatus + ' ' + errorThrown);
            console.log(jqXHR.responseText);
        },
        timeout: 10000
    });
}

// Support iOS virtual keyboard "done" button
function onLightEditBlur(e) {
    if (e.target.nodeName === "INPUT") {
        setObjName(e.target);
    }
}

// Desktop and Android enter key
function onLightEditKeyup(e) {
    if (e.keyCode === 13) { // enter
        if (e.target.nodeName === "INPUT") {
            e.target.blur();
            //setObjName(e.target); // will be handled by blur handler
        }
    }
}

function initEditPage() {
    //colorCanvas = document.createElement('canvas');
    //colorCtx = colorCanvas.getContext('2d');
    pageEditWidth = pageLightEdit.clientWidth;

    // touch handler
    editHammer = new Hammer(pageLightEdit, {
        drag_min_distance: 1,
        prevent_default: true,
        swipe: false,
        drag_horizontal: false,
        transform: false,
        hold: false
    });

    editHammer.ontap = function(e) {
      var el = e.originalEvent.target;
      var action = $(el).data("action");

      if (el.nodeName == 'INPUT') {
        el.focus();
        return true;
      }

      if (el.nodeName == 'A') {
        stopSendCheck();

        if (el.href == '/') {
            history.back();
        }
        else {
            location.assign(el.href);
        }
        return true;
      }

      if (action !== undefined) {
          if (action === "close") {
              stopSendCheck();
              location.href = '/'; // go back but reload dynamic data
          }
      }

      e.originalEvent.preventDefault();
    };

    editHammer.ondoubletap = function(e) {
        e.originalEvent.preventDefault();
    };

    editHammer.ondragend = function(e) {
        touchType = e.originalEvent.type;
        touch0Prev.x = touch0.x;
        touch0Prev.y = touch0.y;

        editNeedRender = true;
        e.originalEvent.preventDefault();
    };

    editHammer.onrelease = function(e) {
        var el = e.originalEvent.target;
        touchType = e.originalEvent.type;
        editNeedRender = true;
        setIsEditing(false);
        moveType = MOVE_NONE;
        sendState();

        if (el.nodeName == 'A') {
            return;
        }

        if (el !== devNameLabel) {
            e.originalEvent.preventDefault();
        }
    };

    editHammer.ondragstart = function(e) {
        if (Modernizr.touch) {
            touch0.x = e.originalEvent.changedTouches[0].pageX;
            touch0.y = e.originalEvent.changedTouches[0].pageY;
        }
        else {
            touch0.x = e.originalEvent.pageX;
            touch0.y = e.originalEvent.pageY;
        }
        touch0Prev.x = touch0.x;
        touch0Prev.y = touch0.y;

        setIsEditing(true);

        var x = touch0.x - pageLightEdit.offsetLeft;

        if (x <= pageEditWidth * 0.259) {
            moveType = MOVE_SAT;
            // console.log('move saturation');
        }
        else if (x <= pageEditWidth * 0.630) {
            moveType = MOVE_COLOR;
            // console.log('move color');
        }
        else if (x <= pageEditWidth) {
            moveType = MOVE_LEVEL;
            // console.log('move level');
        }

        touchType = e.originalEvent.type;
        editNeedRender = true;
        e.originalEvent.preventDefault();
    };

    editHammer.ondrag = function(e) {
        touchType = e.originalEvent.type;
        if (Modernizr.touch) {
            touch0.x = e.originalEvent.changedTouches[0].pageX;
            touch0.y = e.originalEvent.changedTouches[0].pageY;
        }
        else {
            touch0.x = e.originalEvent.pageX;
            touch0.y = e.originalEvent.pageY;
        }
        editNeedRender = true;
        e.originalEvent.preventDefault();
    };
}

function rgb2hsv (r,g,b) {
 var computedH = 0;
 var computedS = 0;
 var computedV = 0;

 //remove spaces from input RGB values, convert to int
 var r = parseInt( (''+r).replace(/\s/g,''),10 );
 var g = parseInt( (''+g).replace(/\s/g,''),10 );
 var b = parseInt( (''+b).replace(/\s/g,''),10 );

 if ( r==null || g==null || b==null ||
     isNaN(r) || isNaN(g)|| isNaN(b) ) {
   alert ('Please enter numeric RGB values!');
   return;
 }
 if (r<0 || g<0 || b<0 || r>255 || g>255 || b>255) {
   alert ('RGB values must be in the range 0 to 255.');
   return;
 }
 r=r/255; g=g/255; b=b/255;
 var minRGB = Math.min(r,Math.min(g,b));
 var maxRGB = Math.max(r,Math.max(g,b));

 // Black-gray-white
 if (minRGB==maxRGB) {
  computedV = minRGB;
  return [0,0,computedV];
 }

 // Colors other than black-gray-white:
 var d = (r==minRGB) ? g-b : ((b==minRGB) ? r-g : b-r);
 var h = (r==minRGB) ? 3 : ((b==minRGB) ? 1 : 5);
 computedH = 60*(h - d/(maxRGB - minRGB));
 computedS = (maxRGB - minRGB)/maxRGB;
 computedV = maxRGB;
 return [computedH,computedS,computedV];
}

function calcColor() {
    var dx = touch0.x - touch0Prev.x;
    var dy = touch0.y - touch0Prev.y;

    touch0Prev.x = touch0.x;
    touch0Prev.y = touch0.y;

    colorPos.y += dy;

    var imgy = colorPos.y % hueHeight;

    if (imgy < 0) {
        imgy = hueHeight + imgy;
    }

    var pos = (hueHeight - imgy) / hueHeight;

    curEdit.hue = pos;

    if (curEdit.hue > 1)
      curEdit.hue = 1;
    else if (curEdit.hue < 0)
      curEdit.hue = 0;

    curEdit.obj.hue = curEdit.hue;

    sendHue = true;
}

// recalculate level based on dy of single finger drag
function calcLevel() {
//    var dx = touch0.x - touch0Prev.x;
    var dy = touch0.y - touch0Prev.y;

    touch0Prev.x = touch0.x;
    touch0Prev.y = touch0.y;

    if (dy !== 0) {
        var accel = 1.0;
        curEdit.levelPercent -= 100 * (dy * accel) / pageEditHeight;
    }

    if (curEdit.levelPercent < 0)
        curEdit.levelPercent = 0;
    else if (curEdit.levelPercent > 100)
        curEdit.levelPercent = 100;

    curEdit.level = Math.floor(curEdit.levelPercent / 100 * 255);

    if (curEdit.level < 0)
      curEdit.level = 0;
    else if (curEdit.level > 255)
      curEdit.level = 255;

    curEdit.obj.levelPercent = curEdit.levelPercent;
    curEdit.obj.level = curEdit.level;

    // check if level changed on/off state
    if (curEdit.level === 0) {
        curEdit.obj.state.on = false;
    }
    else {
        curEdit.obj.state.on = true;
    }

    sendLevel = true;
}

// recalculate level based on dy of single finger drag
function calcSaturation() {
//    var dx = touch0.x - touch0Prev.x;
    var dy = touch0.y - touch0Prev.y;

    touch0Prev.x = touch0.x;
    touch0Prev.y = touch0.y;

    if (dy !== 0) {
        var accel = 1.0;
        curEdit.satPercent -= 100 * (dy * accel) / pageEditHeight;
    }

    curEdit.sat = Math.floor(curEdit.satPercent / 100 * 255);

    if (curEdit.satPercent < 0)
        curEdit.satPercent = 0;
    else if (curEdit.satPercent > 100)
        curEdit.satPercent = 100;

    if (curEdit.sat < 0)
      curEdit.sat = 0;
    else if (curEdit.sat > 255)
      curEdit.sat = 255;

    curEdit.obj.satPercent = curEdit.satPercent;
    curEdit.obj.sat = curEdit.sat;

    sendSat = true;
}

function renderLevel() {
    if (curEdit.obj.state.on === false) {
        levelStateLabelValue.innerHTML = "Off";
        curEdit.levelPercent = 0;
    }

    var level = curEdit.levelPercent > 0 ? curEdit.levelPercent : 1;
    var dh = (canvas0ClientHeight * 0.9) * (level / 100);
    var dy = (canvas0ClientHeight / 2) - (dh / 2);

    levelStateLabelValue.innerHTML = Math.floor(curEdit.levelPercent) + "%";

    var val = "";

    if (Modernizr.csstransforms3d) {
        val = 'scale3d(1,' + curEdit.levelPercent / 100 + ', 1)';
    }
    else if (Modernizr.csstransforms) {
        val = 'scale(1,' + curEdit.levelPercent / 100 + ')';
    }

    barLevel.style[transformProp] = val;
}

function renderSat() {
    var sat = curEdit.satPercent > 0 ? curEdit.satPercent : 1;
    var dh = (canvas0ClientHeight * 0.9) * (sat / 100);
    var dy = (canvas0ClientHeight / 2) - (dh / 2);

    satStateLabelValue.innerHTML = Math.floor(curEdit.satPercent) + "%";

    var val = "";

    if (Modernizr.csstransforms3d) {
        val = 'scale3d(1,' + curEdit.satPercent / 100 + ', 1)';
    }
    else if (Modernizr.csstransforms) {
        val = 'scale(1,' + curEdit.satPercent / 100 + ')';
    }

    barSat.style[transformProp] = val;
}

function renderHue() {
    colorMap.style.backgroundPosition = colorPos.x + "px " + colorPos.y + "px";
}

function renderDimmEdit(t) {
    if (!editNeedRender) {
        requestAnimationFrame(renderDimmEdit);
        return;
    }

    editNeedRender = false; // mark as rendered

    if (moveType === MOVE_LEVEL) {
        calcLevel();
        renderLevel();
    }
    else if (moveType === MOVE_COLOR) {
        calcColor();
        sendSat = true;
        renderHue();
    }
    else if (moveType === MOVE_SAT) {
        calcSaturation();
        sendHue = true;
        renderSat();
    }

    if (pageLightEdit.style.opacity !== 0) {
        pageLightEdit.style.opacity = 1;
    }

    requestAnimationFrame(renderDimmEdit);
}

function adjustLevelEditPage() {
    var pageHeight = pageLightEdit.clientHeight;

    canvas0ClientWidth = 48;
    canvas0ClientHeight = Math.floor(pageHeight * dimmHeight);

    barLevel.style.top  = "15%";
    barLevel.style.right  = "36px";
    //barLevel.width  = canvas0ClientWidth;
    barLevel.height = canvas0ClientHeight;
    // barLevel.style.width  = canvas0ClientWidth + "px";
    barLevel.style.height = canvas0ClientHeight + "px";

    barSat.style.top  = "15%";
    barSat.style.left  = "36px";
    // barSat.width  = canvas0ClientWidth;
    barSat.height = canvas0ClientHeight;
    // barSat.style.width  = canvas0ClientWidth + "px";
    barSat.style.height = canvas0ClientHeight + "px";

    canvasColorClientWidth = Math.floor(winInnerWidth * colorWidth);
    canvasColorClientHeight = Math.floor(winInnerHeight * colorHeight);
    canvasColorClientWidth = 30;
    canvasColorClientHeight = 50;

    colorMap.width  = canvasColorClientWidth;
    colorMap.height = canvasColorClientHeight;
    colorMap.style.top  = "15%";
    colorMap.style.left  = 35 + "%";
    colorMap.style.width  = canvasColorClientWidth + "%";
    colorMap.style.height = canvasColorClientHeight + "%";

    // footer fixed at the bottom
    pageLightEdit.style.height = winInnerHeight + "px";

    var footerWidth = footer.clientWidth;
    pageEditWidth = pageLightEdit.clientWidth;
    pageEditHeight = pageLightEdit.clientHeight;
    footer.style.left = ((pageEditWidth / 2) - (footerWidth / 2)) + "px";
}

function lightEditSetHue(hue) {
  colorPos.y = hueHeight - (hueHeight * hue);
}

function showLightEditPage() {
  $(document.body).addClass("darkBg");
  $(pageLightEdit).removeClass("pageHide");
  winInnerWidth = window.innerWidth;
  winInnerHeight = window.innerHeight;
  moveType = MOVE_NONE;

  detectVendorPrefixes();

  curPage = pageLightEdit;

  var hue = 0;

  if (curEdit.obj.state.hue) {
    hue = curEdit.obj.state.hue / 182.04444;
    hue = hue / 360;
    if (hue < 0) {
        hue = 0;
    }
    else if (hue > 1) {
        hue = 1;
    }
    curEdit.obj.hue = hue;
    console.log("hue: " + hue);
  }

  lightEditSetHue(hue);
  colorMap.style.backgroundPosition = colorPos.x + "px " + colorPos.y + "px";
  colorMapHeight = colorMap.clientHeight;

  sendLevel = false;
  sendSat = false;
  sendHue = false;
  devNameLabel.value = curEdit.obj.name;
  curEdit.levelPercent = curEdit.obj.levelPercent;
  curEdit.satPercent = curEdit.obj.satPercent;
  curEdit.hue = curEdit.obj.hue;
  curEdit.sat = curEdit.obj.sat;

  editNeedRender = true;
  renderLevel();
  renderHue();
  renderSat();
  requestAnimationFrame(renderDimmEdit);

  $(colorMap).removeClass('colorMapHidden');

    document.addEventListener("blur", onLightEditBlur, true);
    document.addEventListener("keyup", onLightEditKeyup, true);

    sendCheckerActive = true;
    sendCheck();
    devNameLabel.blur();

    // hide url bar
    setTimeout(function () {
        window.scrollTo(0, 1);
    }, 10);
}

function hideLightEditPage() {
    sendCheckerActive = false;
    $(document.body).removeClass("darkBg");
    sendLevel = false;

    $(pageLightEdit).addClass("pageHide");
  //document.removeEventListener('touchstart', editOnTouchStart);
  //document.removeEventListener('touchend', editOnTouchEnd);
  //document.removeEventListener('touchmove', editOnTouchMove);
    document.removeEventListener("blur", onLightEditBlur, true);
    document.removeEventListener("keyup", onLightEditKeyup, true);
}
