

var curInput = undefined;
var group = undefined;
var groupId = 0;
var sceneId = 0;

function addScene(name) {

	var out = { "name" : name };
    $.ajax({
        url: '/api/' + apikey + '/groups/' + groupId + '/scenes',
        type: 'POST',
        dataType: 'json',
        processData: false,
        data: JSON.stringify(out),
        success: function(json) {
            location.reload(true);
        },
        error: function(jqXHR, textStatus, errorThrown) {
        	showAlert('alert-error', "Create scene failed.");
        },
        timeout: 1000,
    });
};

function storeScene(sid) {
    $.ajax({
        url: '/api/0/ZLL/group/storescene?rgid=' + groupId + '&sid=' + sid,
        type: 'PUT',
        success: function(data) {
        	showAlert('alert-info', "Stored scene.");
        },
        error: function(jqXHR, textStatus, errorThrown) {
            showAlert('alert-error', "Stored scene failed.");
        },
        timeout: 1000,
    });
};

function removeScene(sid) {
    $.ajax({
        url: '/api/0/ZLL/group/removescene?rgid=' + groupId + '&sid=' + sid,
        type: 'PUT',
        success: function(data) {
            location.reload(true);
        },
        error: function(jqXHR, textStatus, errorThrown) {
			showAlert('alert-error', "Delete scene failed.");
        },
        timeout: 2000,
    });
};

function setSceneName(name) {
    $.ajax({
        url: '/api/0/ZLL/group/setscenename?rgid=' + groupId + '&sid=' + sceneId  + '&name=' + name,
        type: 'PUT',
        success: function(data) {
			showAlert('', "Scene renamed.");
        },
        error: function(jqXHR, textStatus, errorThrown) {
        	showAlert('alert-error', "Rename scene failed.");
        },
        timeout: 8000
    });
}

// Desktop and Android enter key
function onSceneEditKeyup(e) {
    if (e.keyCode === 13) { // enter
        if (e.target.nodeName === "INPUT") {
			e.target.blur();
		}
    }
}

// Support iOS virtual keyboard "done" button
function onSceneEditBlur(e) {
	if (e.target.nodeName === "INPUT") {
		if ($(e.target).data("sid") !== undefined) {
			sceneId = $(e.target).data("sid");
			setSceneName(e.target.value);
		}
	}
}

function prepareDeleteScene(id, name) {
    sceneId = id; // remember
    $('#deleteSceneQuestionLabel').html('Do you really want to delete scene <b>' + name + '</b>?');
}

function buildScenes(group) {

	var txt = "";

	for (var i = 0; i < group.scenes.length; i++) {
		var scene = group.scenes[i];

		txt += '<div class="row">';
		txt += '<div class="span12">';

		txt += '<input name="' + scene.name + '" value="' + scene.name + '" data-rgid="' + group.id + '" data-sid="' + scene.id + '">';
		txt += '<a class="btn actionButton" href="#" onclick="storeScene(' + scene.id + '); return false;">store</span>';
     	txt += '<a class="btn btn-danger actionButton" href="#deleteModal" data-toggle="modal" onclick="prepareDeleteScene(' + scene.id + ',\'' + scene.name + '\');return false;">delete</a>';

		txt += '</div>';
		txt += '</div>';
	}

	var div = document.querySelector('.sceneList');
	div.innerHTML = txt;


	//document.addEventListener(clickevent, onSceneEditClick, false);
	document.addEventListener("blur", onSceneEditBlur, true);
    document.addEventListener("keyup", onSceneEditKeyup, true);
}

function loadScenes() {
    $.ajax({
        url: '/api/' + apikey + '/groups/' + groupId,
        dataType: 'json',
        processData: false,
        headers: { 'Accept': apiversion },
        success: function(json) {

            if (typeof(json) !== 'object') {
                console.log("unexpected response " + typeof(json));
                return;
            }

            group = json;

            if (group.scenes !== 'undefined') {
            	buildScenes(group);
            }
        },
        error: function(jqXHR, textStatus, errorThrown) {
			showAlert('alert-error', "Load scenes failed.");
        },
        timeout: 8000
    });
}

$(document).ready(function() {
    groupId = getURLParameter("group");

    if (groupId !== null) {
 	   loadScenes();
	}
});
